/* if.c */

#include "vpt.h"

/*	============================================================
	Do an IF command. 
*/

void
ifthen(void)
{
	char mode, op;
	KCHAR c;
	int cmp;
	u_int v1, v2;
	char buff1[200], buff2[200];
	
	char *emsg="if/then string compare";
	
	returnkey(c=getnonb());
	
	/* see if string or value, if not delim then mode is 0 for numeric */
	
	mode=isdelm(c);		/* this sets mode==0 if not valid delim */
	if(mode) getstring(buff1, sizeof(buff1)-2, emsg);
	else v1=getval(0);
	
	/*	parse off an operator, valid choices are:
			1	-	=
			2	-	<
			3	-	>
			4	-	<= or =<
			5	-	>= or =>
			6	-	<>
	*/
	
	returnkey(getnonb());	/* skip over any blanks */
	for(op=0 ; ; )
	{
		c=getkey();
		if		(c=='=') c=1;
		else if(c=='<') c=2;
		else if(c=='>') c=4;
		else
		{
			returnkey(c);
			break;
		}
		if((op|c)==op)	  /* if this op bit already set error */
		{
			op=7;
			break;
	 	}
		op|=c;
	}
	if(op==0 || op>=7) error("Illegal operator for IF comparison");
	
	returnkey(c=getnonb());
	
	if(mode)
	{
		if(isdelm(c)==0) error("Delimited string expected");
		getstring(buff2, sizeof(buff2)-2, emsg);
	}
	else v2=getval(0);
	
	c=1;
	if(mode)
	{
		cmp=strcmp(buff1, buff2);
		switch(op)
		{
			case 1:
				if(cmp == 0) c=0;
				break;
			
			case 2:
				if(cmp < 0) c=0;
				break;
			
			case 3:
				if(cmp > 0) c=0;
				break;
			
			case 4:
				if(cmp <= 0) c=0;
				break;
			
			case 5:
				if(cmp >= 0) c=0;
				break;
			
			case 6:
				if(cmp != 0) c=0;
				break;
				
			default:
				break;		/* should never happen! */
		}
	}
	else switch (op)
	{
		case 1:
			if(v1 == v2) c=0;
			break;
		
		case 2:
			if(v1 < v2) c=0;
			break;
		
		case 3:
			if(v1 <= v2) c=0;
			break;
		
		case 4:
			if(v1 > v2) c=0;
			break;
		
		case 5:
			if(v1 >= v2) c=0;
			break;
		
		case 6:
			if(v1 != v2) c=0;
			break;
		
		default:
			break;		/* should never happen */
	}
	if(c) returnkey('*');	/* treat rest of line as comment */
}
