/* miscmds.c

   Miscellaneous command line commands
*/

#include "vpt.h"


/*	============================================================
	This is called by the .NL command and from format when checking
	for widows. It does a new page if needed.
*/

void
pgifneed(u_int t)
{
	if(t && getbotmarg()-getlnum()<t) startcol();
}

/*	============================================================
	Include text in print string for whens (.pr). This just takes
	the specified string and shoves it on to the input stack with a
	trailing CR and gets the main print routine to look after it. Note
	that fonts, etc. will be changed if included in the text. The commands
	following the PR() will be taken care of after the line(s) are done.
   	
   	Note that PR() does not have it's own attribute table--it uses the same
   	as the main body!
*/

void
printinc(void)
{
	char buff[200];
	int m;
	
	incomment++;
	getdstring(buff, sizeof(buff)-2, "PR string");
	incomment--;
	m=addmacro(buff);
	pushkbuff();
	doline();
	while(getkey()!=INT_DELIM);
	pullkbuff();
	killmacro(m);
}


/*	============================================================
	Do a series of blank lines 
   	
   	If at the top of a page the blanks will be done.
   	If at the bottom we will just advance to the top of the next page
*/

void
do_n_lines(void)
{
	u_int t;
	
	skipequal();
	if((t=getval(0))!=0)	  /* don't do anything if 0 lines... */
	{
	
		/*	Check to see if we are at the top of a page. If at top
			we do the top margin before doing the blank lines. Note
			that dotopmargin() also takes care of the top_of_page WHEN
		*/
		
		if(getlnum()<=1) dotopmargin();
		
		/* advance T lines or to page bottom */
		
		while(t-- && getlnum()<=getbotmarg()) blankline();
	}
}


/*	============================================================
	Set the tab fill character. Note that we can have a modifier
	for this since there are different fill chars for margins and
	main body.
*/

void
settabfill(void)
{
	KCHAR c;
	
	c=getkey();
	
	if(f_toupper(c)=='M') setmtabfill();
	else
	{
		returnkey(c);
		skipequal();
		tabfill=getBval(' ');
	}
}
