/* prefix.c */

#define PREFIX

#include "vpt.h"
#include "att_table.h"
#include "prefix.h"

/*	============================================================
	Set the line prefix/suffix size and text .PS[m]=[] .PE[m]=[]
*/

void
setlp(void)
{
	char buff[100];
	KCHAR fbuff[200];
	u_char c;
	
	u_int *linesize;
	Att_table *table;
	char **data;
	
	c=getkey();
	if(f_toupper(c)=='M')
	{
		table=&mnprefix_atts;
		linesize=&mnlineprefixsize;
		data=&mnlineprefix;
	}
	else
	{
		returnkey(c);
		table=&prefix_atts;
		linesize=&lineprefixsize;
		data=&lineprefix;
	}
	
	if(*data)
	{
		free (*data);
		*data=NULL;
	}
	
	skipequal();
	getdstring(buff, sizeof(buff)-5, "line prefix definition");
	if(buff[1] != INT_DELIM)
	{
		*data=strdup(buff);
		memcpy(table, getbodyatts(), sizeof(Att_table));
		memcpy(&temp_atts, table, sizeof(Att_table));
		returnstr(*data);
		*linesize=fillbuff(fbuff, fbuff+sizeof(fbuff)-2,
							10*msperin, 0, 0, &temp_atts, FMT_PREFIX);
		while(getkey()!=INT_DELIM);
	}
}

void
setls(void)
{
	char buff[100];
	KCHAR fbuff[200];
	u_char c;
	
	u_int *linesize;
	Att_table *table;
	char **data;
	
	c=getkey();
	if(f_toupper(c)=='M')
	{
		table=&mnsuffix_atts;
		linesize=&mnlinesuffixsize;
		data=&mnlinesuffix;
	}
	else
	{
		returnkey(c);
		table=&suffix_atts;
		linesize=&linesuffixsize;
		data=&linesuffix;
	}
	
	if(*data)
	{
		free (*data);
		*data=NULL;
	}
	
	skipequal();
	getdstring(buff, sizeof(buff)-5, "Line suffix definition");
	if(buff[1] != INT_DELIM)
	{
		*data=strdup(buff);
		memcpy(table, getbodyatts(), sizeof(Att_table));
		memcpy(&temp_atts, table, sizeof(Att_table));
		returnstr(*data);
		*linesize=fillbuff(fbuff, fbuff+sizeof(fbuff)-2,
			10*msperin, 0, 0, &temp_atts, FMT_SUFFIX);
		while(getkey()!=INT_DELIM);
	}
}

/*	======================================================================
	Set the line prefix sizes after an MS=
*/

void
ms_prefix(u_int n)
{
	lineprefixsize = ms_adjust(lineprefixsize, n);
	linesuffixsize = ms_adjust(linesuffixsize, n);
	mnlineprefixsize = ms_adjust(mnlineprefixsize, n);
	mnlinesuffixsize = ms_adjust(mnlinesuffixsize, n);
}
