/* smallspace.c */

#include "vpt.h"
#include "codes.h"

static struct
{
	u_int	ss_size;
	Codes	*ss_codes;
}smallspace;


/*	============================================================
	Set the small space codes
*/

void
setss(void)
{
	skipequal();
	
	smallspace.ss_size=getval(0);
	setcodes(&smallspace.ss_codes, "smallspace");
}

/*	============================================================
	Tell if small space codes have been defined. Returns the size
	of a small space (0==not defined)
*/

int
smallspacesize(void)
{
	return smallspace.ss_size; 
}

/* ============================================================
   Output the smallspace sequence
*/

void
sendsmallspace(void)
{
	if(printpg) docodes(smallspace.ss_codes);
}

/* 	======================================================================
	Adjust the small space size after a MS=
*/

void
ms_smallspace(u_int n)
{
	smallspace.ss_size=ms_adjust(smallspace.ss_size, n);
}
