/* tabs.c */

#include "vpt.h"


static u_int tabstops[10];

/*	============================================================
	Tokenize a tab
*/

void
toktab(void)
{
	KCHAR c=getkey();
	
	if(!f_isdigit(c)) unknowntab();
	returnkey((c-'0')+INT_TAB);
}

/*	============================================================
	Tokenize a dynamic set-tab
*/

void
toksettab(void)
{
	KCHAR c=getkey();
	
	if(!f_isdigit(c)) unknowntab();
	returnkey((c-'0')+INT_TABSET);
}

/*	============================================================
	Set a tab stop
*/

void
settab(void)
{
	KCHAR c;
	
	c=getkey();
	if(!f_isdigit(c)) unknowntab();
	skipequal();
	tabstops[c-'0']=getval(1);  /* set value in MS */
}

/*	============================================================
	Return the value of a tabstop
*/

int
gettabvalue(int t)
{
	return tabstops[t];
}


void
setdytab(int t, int value)
{
	if(t<0 || t>9) unknowntab();
	tabstops[t]=value;
}

void
unknowntab(void)
{
	error("Unknown tab stop");
}

/*	============================================================
	This is needed by state to get the size of the tab buffer and its address.
*/

void
gettabstate(int *s, char **p)
{
	*s=sizeof(tabstops);
	*p=(char *) &tabstops[0];
}

/*	======================================================================
	Adjust the tab stops after a MS=
*/

void
ms_tabs(u_int n)
{
	u_int t;
	
	for(t=0; t<arraysize(tabstops); t++)
		tabstops[t] = ms_adjust(tabstops[t], n);
}
