/* translate.c */

#include "vpt.h"

static u_char transtbl[0x100]; /* translation table for 0x20..0xff   */

/*	============================================================
	Initialize the translation table
*/

void
init_translate(void)
{
	int t;
	
	for(t=0; t<sizeof(transtbl); t++) transtbl[t]=t;
}

/*	============================================================
	Translate a character. This is called from printline() only
	if the translate flag is set.
*/

int
translatechar(KCHAR c)
{
	if(c<sizeof(transtbl)) c=transtbl[c];
	return c;
}

/*	============================================================
	Define the translation table
	
	Note that init has already defined the table to correspond with
	normal ascii characters.
	
	TT tablepos=newvalue
	
	Optionally, a list can be used: t1=n1,t2=n2,t3=n3,...
*/

void
def_trtbl(void)
{
	KCHAR pos, new;
	
	skipequal();
	do
	{
		returnkey(getnonb());
		pos=getval(0);  /* get char to change */
		
		if(getnonb()!='=')
			error("= needed in defining translation table");
		
		returnkey(getnonb());
		new=getval(0);  /* get new char */
		
		if(!f_isprintable(pos) || !f_isprintable(new))
			error("Illegal translation value");
		
		transtbl[pos]=new;
	}
	while(comma_ck());
}
