/* wait.c */

#include "vpt.h"
#include "codes.h"

static char pauseflag;

static Codes *waitcodes;

static char *waitmessage[10];

/*	============================================================
	Do a page pause if the flag is set, called at the top of each
	page after the print flags have been set.
*/

void
pausepage(void)
{
	char buff[100];
	
	if(pauseflag && printpg)
	{
		fputs("\nInsert new page, press <ENTER> when ready: ", stderr);
		fflush(stderr);
		fgets(buff, sizeof(buff)-2, stdin);
		putc('\n', stderr);
	}
}


/*	============================================================
	Set the page-pause flag (pp=on/off)
*/

void
setpauseflag(void)
{
	pauseflag=getonoff();
}


/*	============================================================
	Define codes to send before a wait
*/

void
setwcodes(void)
{
	skipequal();
	setcodes(&waitcodes, "wait code");
}

/*	============================================================
	Set wait messages -- .w0..w9=[text]
*/

void
setwaitmsg(int t)
{
	char buff[200];
	
	if(waitmessage[t])
	{
		free(waitmessage[t]);
		waitmessage[t]=NULL;
	}
	skipequal();
	getstring(buff, sizeof(buff)-2, "wait message");
	waitmessage[t]=strdup(buff);
}

/*	============================================================
	Tokenize embedded wait cmd
*/

void
tokwait(void)
{
	KCHAR c=getkey();
	
	if(!f_isdigit(c)) error("Unknown wait buffer");
	returnkey((c-'0')+INT_WAIT);
}


/*  ============================================================
	Do a wait if embedded \w0..\w9 encountered
*/

void
dowait(int t)
{
	char *p;
	char buff[100];
	
	if(printpg)
	{
		docodes(waitcodes);
		if((p=waitmessage[t])==NULL) p="waiting....";
		fputs(p, stderr);
		fflush(stderr);
		fgets(buff, sizeof(buff)-2, stdin);
		putc('\n', stderr);
	}
}
